#Raspberry Pi3 Safteshutdown via GPIO Pins
#Pi3 Wiring - Switch suits latching switches, you can adjust to momentary by commenting out below
#
#Reset Switch -  One PIN to PIN 3 which is GPIO 2 - UARTO TX, the other can be Pin6 Ground
#Power Switch - One PIN to PIN 5 which is GPIO 3, Ground can be PIN9
#LED - really needs 330ohm Resistor on the Positive LEG of the LED, Ground to PIN14
#PIN diagram: https://bloggerbrothers.files.wordpress.com/2017/01/rp2_pinout.png?w=663
#
#miniNES Builders Facebook Page - https://www.facebook.com/groups/miniNESbuilders/
#Please note I did not develop the script below, Full credit to who ever uploaded this: https://mega.nz/#!ctlyEAAL!7ho2WMlYa9p6j7ye_hLdfthjb_xjTegLZWHyTzXTyQY
#
#
#Instructions:
# See Readme

import RPi.GPIO as GPIO
import time
import os
import thread

POWERPLUS = 3
RESETPLUS = 2
LED = 14

GPIO.setwarnings(False)		# no warnings
GPIO.setmode(GPIO.BCM)		# set up BCM GPIO numbering 
 
GPIO.setup(RESETPLUS, GPIO.IN, pull_up_down=GPIO.PUD_UP)
# GPIO on pin 3 is the GPIO 2 in BCM mode
#to Reset+

GPIO.setup(POWERPLUS, GPIO.IN, pull_up_down=GPIO.PUD_UP)
# GPIO on pin 5 is the GPIO 3 in BCM mode
#to Power+

GPIO.setup(LED, GPIO.OUT)
GPIO.output(LED, True)
# GPIO on pin 8 is the GPIO 14 in BCM mode
#to LED+

  
# Define a threaded callback function to run in another thread when events are detected  
def button_pressed(channel):
	if channel == POWERPLUS:
		speed=0.15
		shutdownstring="shutdown -h now"
	elif channel == RESETPLUS:
		speed=0.05
		shutdownstring="shutdown -r now"

	thread.start_new_thread( blink, (speed, ))
	os.system(shutdownstring)
	#GPIO.cleanup()
	# no clean up as it was turning off the LED but anyway the system is shutting down
	quit()
	
def blink(speed):
	while True:  
			GPIO.output(LED, False)
			time.sleep(speed)
			GPIO.output(LED, True)
			time.sleep(speed)

GPIO.add_event_detect(RESETPLUS, GPIO.FALLING, callback=button_pressed)

# Uncomment the power switch you use

# Uncomment the line bellow for a latching switch 
# GPIO.add_event_detect(POWERPLUS, GPIO.RISING, callback=button_pressed)

# Uncomment the line bellow for a momentary switch
GPIO.add_event_detect(POWERPLUS, GPIO.FALLING, callback=button_pressed)

while True:
	time.sleep(0.2)
